PlateauImpl

Package | Class | Tree | Deprecated | Index | Help

PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## chkoba
Class PlateauImpl

    java.lang.Object
      java.rmi.server.RemoteObject
          java.rmi.server.RemoteServer
              java.rmi.server.UnicastRemoteObject
                  chkoba.PlateauImpl

All Implemented Interfaces:
  IPlateau, java.io.Serializable, java.rmi.Remote

    public class PlateauImpl

extends java.rmi.server.UnicastRemoteObject
implements IPlateau

Classe Plateau

See Also:
  Serialized Form

Field Summary
`private java.util.ArrayList<ICarte>` | `dernierPlis` Une liste contenant les dernieres cartes prises
`private static IJoueur` | `joueurCourant` Le joueur courant
`private static java.util.ArrayList<IJoueur>` | `joueurs` La liste de tous les joueurs
`private static java.util.ArrayList<IJoueurA>` | `joueursA` La liste de tous les joueurs automatiques
`private static java.util.ArrayList<IJoueurM>` | `joueursM` La liste de tous les joueurs manuels
`private static int` | `nbJoueursIA` Le nombre de joueurs automatiques
`private static int` | `nbJoueursMan` Le nombre de joueurs manuels
`protected static IPioche` | `p` La pioche du plateau
`private static java.util.Properties` | `pro` Variable contenant les proprietes de la machine
`private static PropertiesPerso` | `propers` Attribut permettant de generer le fichier configuration.properties
`private static ITapis` | `tapis` Le tapis du plateau
`private static java.util.ArrayList<IJoueur>` | `team1` La liste contenant les numeros des joueurs allie dans la premiere equipe
`private static java.util.ArrayList<IJoueur>` | `team2` La liste contenant les numeros des joueurs allie dans la seconde equipe

Fields inherited from class java.rmi.server.RemoteObject
`ref`

Constructor Summary
`PlateauImpl()` Constructeur initialisant un plateau : Creation d'une pioche Creation d'un tapis Initialisation "fausse" du dernier plis

Method Summary

`java.lang.String`

`affiche()`
Affiche le plateau :
La pioche
Le tapis
Le jouer courant
Les joueurs

`void` | `ajouteJoueur(java.lang.String nom)` Methode pour ajouter un joueur lors d'un jeu en reseau e deux joueurs
`void` | `ajouteJoueursIA()` Ajoute les joueurs automatiques jusuq'a ce qu'il n'y ait plus de place
`void` | `effacerPlis()` Permet d'effacer le dernier plis odnc utilise quand un joueur se defausse.
`java.util.ArrayList<ICarte>` | `getDernierPlis()` Permet d'obtenir le dernier pli obtenu.
`java.util.ArrayList<IJoueur>` | `getEquipe1()` Retourne la liste symbolisant l'equipe 1
`java.util.ArrayList<IJoueur>` | `getEquipe2()` Retourne la liste symbolisant l'equipe 2
`IJoueur` | `getJoueurCourant()` Retourne le joueur courant
`java.util.ArrayList<IJoueur>` | `getJoueurs()` Retourne la liste de joueurs
`java.util.ArrayList<IJoueurA>` | `getJoueursA()` Retourne la liste de joueurs automatiques
`java.util.ArrayList<IJoueurM>` | `getJoueursM()` Retourne la liste de joueurs manuels
`int` | `getNbJoueursMan()` Retourne le nombre de joueurs manuels
`IPioche` | `getPioche()` Retourne la pioche
`ITapis` | `getTapis()` Retourne le tapis
`void` | `jeuADeux(java.util.ArrayList<java.lang.Integer> manuels)` Methode qui initialise les joueurs dans un jeu a deux joueurs.
`void` | `jeuAQuatre(java.util.ArrayList<java.lang.Integer> tm1, java.util.ArrayList<java.lang.Integer> tm2, java.util.ArrayList<java.lang.Integer> manuels)` Idem que la methode au dessus mais pour 4 joueurs
`static IPlateau` | `lookup()` Methode pour recuperer tous les objets sur le reseau
`void` | `majDernierPli(ICarte cMain, java.util.ArrayList<ICarte> cTapis)` Permet de memorise le dernier plis de chaque joueur pour l'affiche au autre.
`ICarte` | `piocher()` Methode qui permet de faire piocher une carte de la pioche
`void` | `poser(ICarte c)` Methode qui permet de faire poser une carte sur le tapis Intervient notemment lorsque le joueur ne peut pas jouer.
`void` | `prendre(ICarte main, java.util.ArrayList<ICarte> tapisenl)` Methode qui permet de prendre une carte passe en premier parametre Avec la ou les cartes passe en parametre Selon les cas, l'araylist contiendra une ou plusieurs cartes
`boolean` | `resteCartes()` Methode qui calcul le nombre de cartes dans les mains et/ou dans la pioche En effet, la condition d'arret du jeu etant qu'il n'y ait plus de cartes ni dans les mains, ni dans la pioche
`void` | `setEquipes(java.util.ArrayList<java.lang.Integer> list)` Reorganise les equipes et les joueurs en fonctions
`void` | `setJoueurCourant()` Methode qui determine automatiquement, en fonction du nombre de joueurs dans la partie, quel sera le prochain joueur courant.
`void` | `setNbJoueursMan(int n)` Affecte le nombre de joueurs manuels du jeu
`void` | `setPioche(IPioche pioche)` Affecte une nouvelle pioche au plateau
`void` | `setTapis(ITapis tapis)` Affecte un nouveau tapis au plateau

Methods inherited from class java.rmi.server.UnicastRemoteObject
`clone, exportObject, exportObject, exportObject, unexportObject`

Methods inherited from class java.rmi.server.RemoteServer
`getClientHost, getLog, setLog`

Methods inherited from class java.rmi.server.RemoteObject
`equals, getRef, hashCode, toString, toStub`

Methods inherited from class java.lang.Object
`finalize, getClass, notify, notifyAll, wait, wait, wait`

Field Detail

### p

    protected static IPioche p

  La pioche du plateau

### tapis

    private static ITapis tapis

  Le tapis du plateau

### pro

    private static java.util.Properties pro

  Variable contenant les proprietes de la machine

### propers

    private static PropertiesPerso propers

  Attribut permettant de generer le fichier configuration.properties

### joueurs

    private static java.util.ArrayList<IJoueur> joueurs

  La liste de tous les joueurs

### joueursA

    private static java.util.ArrayList<IJoueurA> joueursA

  La liste de tous les joueurs automatiques

### joueursM

    private static java.util.ArrayList<IJoueurM> joueursM

  La liste de tous les joueurs manuels

### joueurCourant

    private static IJoueur joueurCourant

  Le joueur courant

### team1

    private static java.util.ArrayList<IJoueur> team1

  La liste contenant les numeros des joueurs allie dans la premiere equipe

### team2

    private static java.util.ArrayList<IJoueur> team2

  La liste contenant les numeros des joueurs allie dans la seconde equipe

### nbJoueursMan

    private static int nbJoueursMan

  Le nombre de joueurs manuels

### nbJoueursIA

    private static int nbJoueursIA

  Le nombre de joueurs automatiques

### dernierPlis

    private java.util.ArrayList<ICarte> dernierPlis

  Une liste contenant les dernieres cartes prises

Constructor Detail

### PlateauImpl

    public PlateauImpl()
                throws java.rmi.RemoteException

  Constructeur initialisant un plateau :
  Creation d'une pioche
  Creation d'un tapis
  Initialisation "fausse" du dernier plis

  Throws:
    `java.rmi.RemoteException`

Method Detail

### getDernierPlis

    public java.util.ArrayList<ICarte> getDernierPlis()
                                               throws java.rmi.RemoteException

  Permet d'obtenir le dernier pli obtenu. Utile lors du jeu en reseau

  Specified by:
    `getDernierPlis` in interface `IPlateau`
  Throws:
    `java.rmi.RemoteException`

### majDernierPli

    public void majDernierPli(ICarte cMain,
                              java.util.ArrayList<ICarte> cTapis)
                       throws java.rmi.RemoteException

  Permet de memorise le dernier plis de chaque joueur pour l'affiche au autre. Utile lors du jeu en reseau

  Specified by:
    `majDernierPli` in interface `IPlateau`
  Throws:
    `java.rmi.RemoteException`

### effacerPlis

    public void effacerPlis()
                     throws java.rmi.RemoteException

  Permet d'effacer le dernier plis odnc utilise quand un joueur se defausse. Utile lors du jeu en reseau

  Specified by:
    `effacerPlis` in interface `IPlateau`
  Throws:
    `java.rmi.RemoteException`

### ajouteJoueur

    public void ajouteJoueur(java.lang.String nom)
                      throws java.rmi.RemoteException

  Methode pour ajouter un joueur lors d'un jeu en reseau e deux joueurs

  Specified by:
    `ajouteJoueur` in interface `IPlateau`
  Throws:
    `java.rmi.RemoteException`

### ajouteJoueursIA

    public void ajouteJoueursIA()
                         throws java.rmi.RemoteException

  Ajoute les joueurs automatiques jusuq'a ce qu'il n'y ait plus de place

  Specified by:
    `ajouteJoueursIA` in interface `IPlateau`
  Throws:
    `java.rmi.RemoteException`

### lookup

    public static IPlateau lookup()
                           throws java.rmi.RemoteException

  Methode pour recuperer tous les objets sur le reseau

  Throws:
    `java.rmi.RemoteException`

### prendre

    public void prendre(ICarte main,
                        java.util.ArrayList<ICarte> tapisenl)
                 throws java.rmi.RemoteException

  Methode qui permet de prendre une carte passe en premier parametre Avec la ou les cartes passe en parametre Selon les cas, l'araylist contiendra une ou plusieurs cartes

  Specified by:
    `prendre` in interface `IPlateau`
  Throws:
    `java.rmi.RemoteException`

### jeuADeux

    public void jeuADeux(java.util.ArrayList<java.lang.Integer> manuels)
                  throws java.rmi.RemoteException

  Methode qui initialise les joueurs dans un jeu a deux joueurs. Cette initialisation doit se faire en differe notemment lorsque le jeu doit se faire en serveur.

  Specified by:
    `jeuADeux` in interface `IPlateau`
  Throws:
    `java.rmi.RemoteException`

### jeuAQuatre

    public void jeuAQuatre(java.util.ArrayList<java.lang.Integer> tm1,
                           java.util.ArrayList<java.lang.Integer> tm2,
                           java.util.ArrayList<java.lang.Integer> manuels)
                    throws java.rmi.RemoteException

  Idem que la methode au dessus mais pour 4 joueurs

  Specified by:
    `jeuAQuatre` in interface `IPlateau`
  Throws:
    `java.rmi.RemoteException`

### piocher

    public ICarte piocher()
                   throws java.rmi.RemoteException

  Methode qui permet de faire piocher une carte de la pioche

  Specified by:
    `piocher` in interface `IPlateau`
  Throws:
    `java.rmi.RemoteException`

### poser

    public void poser(ICarte c)
               throws java.rmi.RemoteException

  Methode qui permet de faire poser une carte sur le tapis Intervient notemment lorsque le joueur ne peut pas jouer.

  Specified by:
    `poser` in interface `IPlateau`
  Throws:
    `java.rmi.RemoteException`

### resteCartes

    public boolean resteCartes()
                        throws java.rmi.RemoteException

  Methode qui calcul le nombre de cartes dans les mains et/ou dans la pioche En effet, la condition d'arret du jeu etant qu'il n'y ait plus de cartes ni dans les mains, ni dans la pioche

  Specified by:
    `resteCartes` in interface `IPlateau`
  Throws:
    `java.rmi.RemoteException`

### affiche

    public java.lang.String affiche()
                             throws java.rmi.RemoteException

  Affiche le plateau :
  La pioche
  Le tapis
  Le jouer courant
  Les joueurs

  Specified by:
    `affiche` in interface `IPlateau`
  Throws:
    `java.rmi.RemoteException`

### setJoueurCourant

    public void setJoueurCourant()
                          throws java.rmi.RemoteException

  Methode qui determine automatiquement, en fonction du nombre de joueurs dans la partie, quel sera le prochain joueur courant. Le premier joueur courant de la partie est le joueur le premier ajouter dans l'arrayList joueurs En mode campagne, c'est le joueur derriere l'ordinateur En mode serveur, c'est celui qui cre le serveur.

  Specified by:
    `setJoueurCourant` in interface `IPlateau`
  Throws:
    `java.rmi.RemoteException`

### setPioche

    public void setPioche(IPioche pioche)
                   throws java.rmi.RemoteException

  Affecte une nouvelle pioche au plateau

  Specified by:
    `setPioche` in interface `IPlateau`
  Throws:
    `java.rmi.RemoteException`

### setTapis

    public void setTapis(ITapis tapis)
                  throws java.rmi.RemoteException

  Affecte un nouveau tapis au plateau

  Specified by:
    `setTapis` in interface `IPlateau`
  Throws:
    `java.rmi.RemoteException`

### setNbJoueursMan

    public void setNbJoueursMan(int n)
                         throws java.rmi.RemoteException

  Affecte le nombre de joueurs manuels du jeu

  Specified by:
    `setNbJoueursMan` in interface `IPlateau`
  Throws:
    `java.rmi.RemoteException`

### setEquipes

    public void setEquipes(java.util.ArrayList<java.lang.Integer> list)
                    throws java.rmi.RemoteException

  Reorganise les equipes et les joueurs en fonctions

  Specified by:
    `setEquipes` in interface `IPlateau`
  Throws:
    `java.rmi.RemoteException`

### getPioche

    public IPioche getPioche()
                      throws java.rmi.RemoteException

  Retourne la pioche

  Specified by:
    `getPioche` in interface `IPlateau`
  Throws:
    `java.rmi.RemoteException`

### getNbJoueursMan

    public int getNbJoueursMan()
                        throws java.rmi.RemoteException

  Retourne le nombre de joueurs manuels

  Specified by:
    `getNbJoueursMan` in interface `IPlateau`
  Throws:
    `java.rmi.RemoteException`

### getJoueurs

    public java.util.ArrayList<IJoueur> getJoueurs()
                                            throws java.rmi.RemoteException

  Retourne la liste de joueurs

  Specified by:
    `getJoueurs` in interface `IPlateau`
  Throws:
    `java.rmi.RemoteException`

### getJoueursA

    public java.util.ArrayList<IJoueurA> getJoueursA()
                                              throws java.rmi.RemoteException

  Retourne la liste de joueurs automatiques

  Specified by:
    `getJoueursA` in interface `IPlateau`
  Throws:
    `java.rmi.RemoteException`

### getJoueursM

    public java.util.ArrayList<IJoueurM> getJoueursM()
                                              throws java.rmi.RemoteException

  Retourne la liste de joueurs manuels

  Specified by:
    `getJoueursM` in interface `IPlateau`
  Throws:
    `java.rmi.RemoteException`

### getTapis

    public ITapis getTapis()
                    throws java.rmi.RemoteException

  Retourne le tapis

  Specified by:
    `getTapis` in interface `IPlateau`
  Throws:
    `java.rmi.RemoteException`

### getJoueurCourant

    public IJoueur getJoueurCourant()
                             throws java.rmi.RemoteException

  Retourne le joueur courant

  Specified by:
    `getJoueurCourant` in interface `IPlateau`
  Throws:
    `java.rmi.RemoteException`

### getEquipe1

    public java.util.ArrayList<IJoueur> getEquipe1()
                                            throws java.rmi.RemoteException

  Retourne la liste symbolisant l'equipe 1

  Specified by:
    `getEquipe1` in interface `IPlateau`
  Throws:
    `java.rmi.RemoteException`

### getEquipe2

    public java.util.ArrayList<IJoueur> getEquipe2()
                                            throws java.rmi.RemoteException

  Retourne la liste symbolisant l'equipe 2

  Specified by:
    `getEquipe2` in interface `IPlateau`
  Throws:
    `java.rmi.RemoteException`

Package | Class | Tree | Deprecated | Index | Help

PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD